/***********************************************************
 * $Id$
 *
 * FancyLibs
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYSOCKCLIENTTERMINATIONLISTENER_H_
#define FANCYSOCKCLIENTTERMINATIONLISTENER_H_

#include <fancysock.h>
#include <fancyobject.h>

namespace Fancy {

class UID;

namespace Sock {

/**
 * An interface implemented by beans, which need to be informed about
 * a remoting client which terminates.
 */
class FANCYSOCK_API ClientTerminationListener: public virtual Fancy::Object {
protected:
    ClientTerminationListener();
    virtual ~ClientTerminationListener();
public:
    typedef Fancy::ObjPtr<ClientTerminationListener> ptr_t;
    virtual void clientTerminated(const Fancy::ObjPtr<Fancy::UID> &clientUID) = 0;
};

}

}

#endif /* FANCYSOCKCLIENTTERMINATIONLISTENER_H_ */
