/***********************************************************
 * $Id$
 *
 * FancyLibs
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYSOCKINVOCATIONAUTHENTICATOR_H_
#define FANCYSOCKINVOCATIONAUTHENTICATOR_H_

#include <fancysock.h>
#include <fancyobject.h>

namespace Fancy {

class Map;
template <class T> class ObjectArray;
class String;
class ReflectionTarget;

namespace Sock {

class InvocationContext;

class FANCYSOCK_API InvocationAuthenticator: public virtual Fancy::Object {
protected:
    InvocationAuthenticator();
    virtual ~InvocationAuthenticator();
public:
    typedef Fancy::ObjPtr<InvocationAuthenticator> ptr_t;

    virtual void authenticate(const Fancy::ObjPtr<InvocationContext> &ctx,
                              const Fancy::ObjPtr<Fancy::ReflectionTarget> &target,
                              const Fancy::ObjPtr<Fancy::String> &method,
                              const Fancy::ObjPtr<Fancy::ObjectArray<Fancy::Object> > &args,
                              const Fancy::ObjPtr<Fancy::Map> &metadata   ) = 0;
};

}

}

#endif /* FANCYSOCKINVOCATIONAUTHENTICATOR_H_ */
