/***********************************************************
 * $Id$
 *
 * FancyLibs
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYSOCKINVOCATIONCONTEXT_H_
#define FANCYSOCKINVOCATIONCONTEXT_H_

#include <fancysock.h>
#include <fancyobject.h>

namespace Fancy {

class UID;

namespace Sock {

/**
 * The context under which a call is invoked. If the context implements
 * {@link CallbackInvocationContext}, the {@link InvocationHandler} may
 * issue a callback to the originating invoker.
 */
class FANCYSOCK_API InvocationContext: public virtual Fancy::Object {
protected:
	InvocationContext();
	virtual ~InvocationContext();
public:
	typedef Fancy::ObjPtr<InvocationContext> ptr_t;

	/**
	 * @return The client UID to which this context belongs.
	 */
	virtual Fancy::ObjPtr<Fancy::UID> getClientUID() const = 0;
};

}

}

#endif /* FANCYSOCKINVOCATIONCONTEXT_H_ */
