/***********************************************************
 * $Id$
 *
 * FancyLibs
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYSOCKRESOLVEOPTIONS_H_
#define FANCYSOCKRESOLVEOPTIONS_H_

#include <fancysock.h>
#include <fancyobject.h>

namespace Fancy {

//class String;
//class Map;

namespace Sock {

/**
 * An interface for contexts, which accept broadcast calls.
 * This interface is the abstraction a server sees from a single client connection.
 */
class FANCYSOCK_API ResolveOptions: public virtual Fancy::Object {
protected:
	virtual ~ResolveOptions();
public:
	typedef Fancy::ObjPtr<ResolveOptions> ptr_t;

	enum StackPolicy {
	    IPv4Only    = 0,
	    PreferIPv4  = 1,
	    PreferIPv6  = 2,
	    IPv6Only    = 3
	};

	static ptr_t newInstance();

	virtual StackPolicy getStackPolicy() = 0;
	virtual void setStackPolicy(StackPolicy policy) = 0;

};

}} // end namespaces

#endif /* FANCYSOCKRESOLVEOPTIONS_H_ */
